blob: 8c8dc8208ba91e0c5bb493fa2f0dd75a2231dd22 [file] [log] [blame]
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +01001#!/bin/bash -eu
2
Rupert Shuttleworth2a4fc3e2021-04-21 07:10:09 -04003set -o pipefail
4
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +01005# This test exercises the bootstrapping process of the build system
6# in a source tree that only contains enough files for Bazel and Soong to work.
7
Lukacs T. Berki3b730c42021-04-08 13:21:13 +02008source "$(dirname "$0")/lib.sh"
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +01009
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -040010readonly GENERATED_BUILD_FILE_NAME="BUILD.bazel"
11
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +010012function test_smoke {
13 setup
14 run_soong
15}
16
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +010017function test_null_build() {
18 setup
19 run_soong
20 local bootstrap_mtime1=$(stat -c "%y" out/soong/.bootstrap/build.ninja)
21 local output_mtime1=$(stat -c "%y" out/soong/build.ninja)
22 run_soong
23 local bootstrap_mtime2=$(stat -c "%y" out/soong/.bootstrap/build.ninja)
24 local output_mtime2=$(stat -c "%y" out/soong/build.ninja)
25
26 if [[ "$bootstrap_mtime1" == "$bootstrap_mtime2" ]]; then
27 # Bootstrapping is always done. It doesn't take a measurable amount of time.
28 fail "Bootstrap Ninja file did not change on null build"
29 fi
30
31 if [[ "$output_mtime1" != "$output_mtime2" ]]; then
32 fail "Output Ninja file changed on null build"
33 fi
34}
35
36function test_soong_build_rebuilt_if_blueprint_changes() {
37 setup
38 run_soong
39 local mtime1=$(stat -c "%y" out/soong/.bootstrap/build.ninja)
40
41 sed -i 's/pluginGenSrcCmd/pluginGenSrcCmd2/g' build/blueprint/bootstrap/bootstrap.go
42
43 run_soong
44 local mtime2=$(stat -c "%y" out/soong/.bootstrap/build.ninja)
45
46 if [[ "$mtime1" == "$mtime2" ]]; then
47 fail "Bootstrap Ninja file did not change"
48 fi
49}
50
51function test_change_android_bp() {
52 setup
53 mkdir -p a
54 cat > a/Android.bp <<'EOF'
55python_binary_host {
56 name: "my_little_binary_host",
57 srcs: ["my_little_binary_host.py"]
58}
59EOF
60 touch a/my_little_binary_host.py
61 run_soong
62
63 grep -q "^# Module:.*my_little_binary_host" out/soong/build.ninja || fail "module not found"
64
65 cat > a/Android.bp <<'EOF'
66python_binary_host {
67 name: "my_great_binary_host",
68 srcs: ["my_great_binary_host.py"]
69}
70EOF
71 touch a/my_great_binary_host.py
72 run_soong
73
74 grep -q "^# Module:.*my_little_binary_host" out/soong/build.ninja && fail "old module found"
75 grep -q "^# Module:.*my_great_binary_host" out/soong/build.ninja || fail "new module not found"
76}
77
78
79function test_add_android_bp() {
80 setup
81 run_soong
82 local mtime1=$(stat -c "%y" out/soong/build.ninja)
83
84 mkdir -p a
85 cat > a/Android.bp <<'EOF'
86python_binary_host {
87 name: "my_little_binary_host",
88 srcs: ["my_little_binary_host.py"]
89}
90EOF
91 touch a/my_little_binary_host.py
92 run_soong
93
94 local mtime2=$(stat -c "%y" out/soong/build.ninja)
95 if [[ "$mtime1" == "$mtime2" ]]; then
96 fail "Output Ninja file did not change"
97 fi
98
99 grep -q "^# Module:.*my_little_binary_host$" out/soong/build.ninja || fail "New module not in output"
100
101 run_soong
102}
103
104function test_delete_android_bp() {
105 setup
106 mkdir -p a
107 cat > a/Android.bp <<'EOF'
108python_binary_host {
109 name: "my_little_binary_host",
110 srcs: ["my_little_binary_host.py"]
111}
112EOF
113 touch a/my_little_binary_host.py
114 run_soong
115
116 grep -q "^# Module:.*my_little_binary_host$" out/soong/build.ninja || fail "Module not in output"
117
118 rm a/Android.bp
119 run_soong
120
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200121 if grep -q "^# Module:.*my_little_binary_host$" out/soong/build.ninja; then
122 fail "Old module in output"
123 fi
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +0100124}
125
Colin Cross10425952021-04-12 18:59:18 -0700126# Test that an incremental build with a glob doesn't rerun soong_build, and
127# only regenerates the globs on the first but not the second incremental build.
128function test_glob_noop_incremental() {
129 setup
130
Colin Crossb72877f2021-04-16 10:09:54 -0700131 # This test needs to start from a clean build, but setup creates an
132 # initialized tree that has already been built once. Clear the out
Lukacs T. Berki731bb912021-04-16 09:16:19 +0200133 # directory to start from scratch (see b/185591972)
Colin Crossb72877f2021-04-16 10:09:54 -0700134 rm -rf out
135
Colin Cross10425952021-04-12 18:59:18 -0700136 mkdir -p a
137 cat > a/Android.bp <<'EOF'
138python_binary_host {
139 name: "my_little_binary_host",
140 srcs: ["*.py"],
141}
142EOF
143 touch a/my_little_binary_host.py
144 run_soong
145 local ninja_mtime1=$(stat -c "%y" out/soong/build.ninja)
146
Colin Crosscb33a002021-04-12 22:25:17 -0700147 local glob_deps_file=out/soong/.primary/globs/0.d
Colin Cross10425952021-04-12 18:59:18 -0700148
149 if [ -e "$glob_deps_file" ]; then
150 fail "Glob deps file unexpectedly written on first build"
151 fi
152
153 run_soong
154 local ninja_mtime2=$(stat -c "%y" out/soong/build.ninja)
155
156 # There is an ineffiencency in glob that requires bpglob to rerun once for each glob to update
157 # the entry in the .ninja_log. It doesn't update the output file, but we can detect the rerun
158 # by checking if the deps file was created.
159 if [ ! -e "$glob_deps_file" ]; then
160 fail "Glob deps file missing after second build"
161 fi
162
163 local glob_deps_mtime2=$(stat -c "%y" "$glob_deps_file")
164
165 if [[ "$ninja_mtime1" != "$ninja_mtime2" ]]; then
166 fail "Ninja file rewritten on null incremental build"
167 fi
168
169 run_soong
170 local ninja_mtime3=$(stat -c "%y" out/soong/build.ninja)
171 local glob_deps_mtime3=$(stat -c "%y" "$glob_deps_file")
172
173 if [[ "$ninja_mtime2" != "$ninja_mtime3" ]]; then
174 fail "Ninja file rewritten on null incremental build"
175 fi
176
177 # The bpglob commands should not rerun after the first incremental build.
178 if [[ "$glob_deps_mtime2" != "$glob_deps_mtime3" ]]; then
179 fail "Glob deps file rewritten on second null incremental build"
180 fi
181}
182
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +0100183function test_add_file_to_glob() {
184 setup
185
186 mkdir -p a
187 cat > a/Android.bp <<'EOF'
188python_binary_host {
189 name: "my_little_binary_host",
190 srcs: ["*.py"],
191}
192EOF
193 touch a/my_little_binary_host.py
194 run_soong
195 local mtime1=$(stat -c "%y" out/soong/build.ninja)
196
197 touch a/my_little_library.py
198 run_soong
199
200 local mtime2=$(stat -c "%y" out/soong/build.ninja)
201 if [[ "$mtime1" == "$mtime2" ]]; then
202 fail "Output Ninja file did not change"
203 fi
204
205 grep -q my_little_library.py out/soong/build.ninja || fail "new file is not in output"
206}
207
Lukacs T. Berkif0b3b942021-03-23 11:46:47 +0100208function test_soong_build_rerun_iff_environment_changes() {
209 setup
210
211 mkdir -p cherry
212 cat > cherry/Android.bp <<'EOF'
213bootstrap_go_package {
214 name: "cherry",
215 pkgPath: "android/soong/cherry",
216 deps: [
217 "blueprint",
218 "soong",
219 "soong-android",
220 ],
221 srcs: [
222 "cherry.go",
223 ],
224 pluginFor: ["soong_build"],
225}
226EOF
227
228 cat > cherry/cherry.go <<'EOF'
229package cherry
230
231import (
232 "android/soong/android"
233 "github.com/google/blueprint"
234)
235
236var (
237 pctx = android.NewPackageContext("cherry")
238)
239
240func init() {
241 android.RegisterSingletonType("cherry", CherrySingleton)
242}
243
244func CherrySingleton() android.Singleton {
245 return &cherrySingleton{}
246}
247
248type cherrySingleton struct{}
249
250func (p *cherrySingleton) GenerateBuildActions(ctx android.SingletonContext) {
251 cherryRule := ctx.Rule(pctx, "cherry",
252 blueprint.RuleParams{
253 Command: "echo CHERRY IS " + ctx.Config().Getenv("CHERRY") + " > ${out}",
254 CommandDeps: []string{},
255 Description: "Cherry",
256 })
257
258 outputFile := android.PathForOutput(ctx, "cherry", "cherry.txt")
259 var deps android.Paths
260
261 ctx.Build(pctx, android.BuildParams{
262 Rule: cherryRule,
263 Output: outputFile,
264 Inputs: deps,
265 })
266}
267EOF
268
269 export CHERRY=TASTY
270 run_soong
271 grep -q "CHERRY IS TASTY" out/soong/build.ninja \
272 || fail "first value of environment variable is not used"
273
274 export CHERRY=RED
275 run_soong
276 grep -q "CHERRY IS RED" out/soong/build.ninja \
277 || fail "second value of environment variable not used"
278 local mtime1=$(stat -c "%y" out/soong/build.ninja)
279
280 run_soong
281 local mtime2=$(stat -c "%y" out/soong/build.ninja)
282 if [[ "$mtime1" != "$mtime2" ]]; then
283 fail "Output Ninja file changed when environment variable did not"
284 fi
285
286}
287
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +0100288function test_add_file_to_soong_build() {
289 setup
290 run_soong
291 local mtime1=$(stat -c "%y" out/soong/build.ninja)
292
293 mkdir -p a
294 cat > a/Android.bp <<'EOF'
295bootstrap_go_package {
296 name: "picard-soong-rules",
297 pkgPath: "android/soong/picard",
298 deps: [
299 "blueprint",
300 "soong",
301 "soong-android",
302 ],
303 srcs: [
304 "picard.go",
305 ],
306 pluginFor: ["soong_build"],
307}
308EOF
309
310 cat > a/picard.go <<'EOF'
311package picard
312
313import (
314 "android/soong/android"
315 "github.com/google/blueprint"
316)
317
318var (
319 pctx = android.NewPackageContext("picard")
320)
321
322func init() {
323 android.RegisterSingletonType("picard", PicardSingleton)
324}
325
326func PicardSingleton() android.Singleton {
327 return &picardSingleton{}
328}
329
330type picardSingleton struct{}
331
332func (p *picardSingleton) GenerateBuildActions(ctx android.SingletonContext) {
333 picardRule := ctx.Rule(pctx, "picard",
334 blueprint.RuleParams{
335 Command: "echo Make it so. > ${out}",
336 CommandDeps: []string{},
337 Description: "Something quotable",
338 })
339
340 outputFile := android.PathForOutput(ctx, "picard", "picard.txt")
341 var deps android.Paths
342
343 ctx.Build(pctx, android.BuildParams{
344 Rule: picardRule,
345 Output: outputFile,
346 Inputs: deps,
347 })
348}
349
350EOF
351
352 run_soong
353 local mtime2=$(stat -c "%y" out/soong/build.ninja)
354 if [[ "$mtime1" == "$mtime2" ]]; then
355 fail "Output Ninja file did not change"
356 fi
357
358 grep -q "Make it so" out/soong/build.ninja || fail "New action not present"
359}
360
Colin Crossc02504e2021-04-08 10:34:16 -0700361# Tests a glob in a build= statement in an Android.bp file, which is interpreted
362# during bootstrapping.
363function test_glob_during_bootstrapping() {
364 setup
365
366 mkdir -p a
367 cat > a/Android.bp <<'EOF'
368build=["foo*.bp"]
369EOF
370 cat > a/fooa.bp <<'EOF'
371bootstrap_go_package {
372 name: "picard-soong-rules",
373 pkgPath: "android/soong/picard",
374 deps: [
375 "blueprint",
376 "soong",
377 "soong-android",
378 ],
379 srcs: [
380 "picard.go",
381 ],
382 pluginFor: ["soong_build"],
383}
384EOF
385
386 cat > a/picard.go <<'EOF'
387package picard
388
389import (
390 "android/soong/android"
391 "github.com/google/blueprint"
392)
393
394var (
395 pctx = android.NewPackageContext("picard")
396)
397
398func init() {
399 android.RegisterSingletonType("picard", PicardSingleton)
400}
401
402func PicardSingleton() android.Singleton {
403 return &picardSingleton{}
404}
405
406type picardSingleton struct{}
407
408var Message = "Make it so."
409
410func (p *picardSingleton) GenerateBuildActions(ctx android.SingletonContext) {
411 picardRule := ctx.Rule(pctx, "picard",
412 blueprint.RuleParams{
413 Command: "echo " + Message + " > ${out}",
414 CommandDeps: []string{},
415 Description: "Something quotable",
416 })
417
418 outputFile := android.PathForOutput(ctx, "picard", "picard.txt")
419 var deps android.Paths
420
421 ctx.Build(pctx, android.BuildParams{
422 Rule: picardRule,
423 Output: outputFile,
424 Inputs: deps,
425 })
426}
427
428EOF
429
430 run_soong
431 local mtime1=$(stat -c "%y" out/soong/build.ninja)
432
433 grep -q "Make it so" out/soong/build.ninja || fail "Original action not present"
434
435 cat > a/foob.bp <<'EOF'
436bootstrap_go_package {
437 name: "worf-soong-rules",
438 pkgPath: "android/soong/worf",
439 deps: [
440 "blueprint",
441 "soong",
442 "soong-android",
443 "picard-soong-rules",
444 ],
445 srcs: [
446 "worf.go",
447 ],
448 pluginFor: ["soong_build"],
449}
450EOF
451
452 cat > a/worf.go <<'EOF'
453package worf
454
455import "android/soong/picard"
456
457func init() {
458 picard.Message = "Engage."
459}
460EOF
461
462 run_soong
463 local mtime2=$(stat -c "%y" out/soong/build.ninja)
464 if [[ "$mtime1" == "$mtime2" ]]; then
465 fail "Output Ninja file did not change"
466 fi
467
468 grep -q "Engage" out/soong/build.ninja || fail "New action not present"
469
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200470 if grep -q "Make it so" out/soong/build.ninja; then
471 fail "Original action still present"
472 fi
Colin Crossc02504e2021-04-08 10:34:16 -0700473}
474
Lukacs T. Berkif0b3b942021-03-23 11:46:47 +0100475function test_null_build_after_docs {
476 setup
477 run_soong
478 local mtime1=$(stat -c "%y" out/soong/build.ninja)
479
480 prebuilts/build-tools/linux-x86/bin/ninja -f out/soong/build.ninja soong_docs
481 run_soong
482 local mtime2=$(stat -c "%y" out/soong/build.ninja)
483
484 if [[ "$mtime1" != "$mtime2" ]]; then
485 fail "Output Ninja file changed on null build"
486 fi
487}
488
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400489function test_bp2build_smoke {
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200490 setup
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400491 GENERATE_BAZEL_FILES=1 run_soong
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200492 [[ -e out/soong/.bootstrap/bp2build_workspace_marker ]] || fail "bp2build marker file not created"
493 [[ -e out/soong/workspace ]] || fail "Bazel workspace not created"
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200494}
495
Jingwen Chen4fabaf52021-05-25 02:40:29 +0000496function test_bp2build_generates_fake_ninja_file {
497 setup
498 create_mock_bazel
499
500 run_bp2build
501
502 if [[ ! -f "./out/soong/build.ninja" ]]; then
503 fail "./out/soong/build.ninja was not generated"
504 fi
505
506 if ! grep "build nothing: phony" "./out/soong/build.ninja"; then
507 fail "missing phony nothing target in out/soong/build.ninja"
508 fi
509}
510
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400511function test_bp2build_add_android_bp {
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200512 setup
513
514 mkdir -p a
515 touch a/a.txt
516 cat > a/Android.bp <<'EOF'
517filegroup {
518 name: "a",
519 srcs: ["a.txt"],
520 bazel_module: { bp2build_available: true },
521}
522EOF
523
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400524 GENERATE_BAZEL_FILES=1 run_soong
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400525 [[ -e out/soong/bp2build/a/${GENERATED_BUILD_FILE_NAME} ]] || fail "a/${GENERATED_BUILD_FILE_NAME} not created"
526 [[ -L out/soong/workspace/a/${GENERATED_BUILD_FILE_NAME} ]] || fail "a/${GENERATED_BUILD_FILE_NAME} not symlinked"
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200527
528 mkdir -p b
529 touch b/b.txt
530 cat > b/Android.bp <<'EOF'
531filegroup {
532 name: "b",
533 srcs: ["b.txt"],
534 bazel_module: { bp2build_available: true },
535}
536EOF
537
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400538 GENERATE_BAZEL_FILES=1 run_soong
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400539 [[ -e out/soong/bp2build/b/${GENERATED_BUILD_FILE_NAME} ]] || fail "a/${GENERATED_BUILD_FILE_NAME} not created"
540 [[ -L out/soong/workspace/b/${GENERATED_BUILD_FILE_NAME} ]] || fail "a/${GENERATED_BUILD_FILE_NAME} not symlinked"
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200541}
542
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400543function test_bp2build_null_build {
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200544 setup
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200545
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400546 GENERATE_BAZEL_FILES=1 run_soong
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200547 local mtime1=$(stat -c "%y" out/soong/build.ninja)
548
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400549 GENERATE_BAZEL_FILES=1 run_soong
Lukacs T. Berkif8e24282021-04-14 10:31:00 +0200550 local mtime2=$(stat -c "%y" out/soong/build.ninja)
551
552 if [[ "$mtime1" != "$mtime2" ]]; then
553 fail "Output Ninja file changed on null build"
554 fi
555}
556
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400557function test_bp2build_add_to_glob {
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200558 setup
559
560 mkdir -p a
561 touch a/a1.txt
562 cat > a/Android.bp <<'EOF'
563filegroup {
564 name: "a",
565 srcs: ["*.txt"],
566 bazel_module: { bp2build_available: true },
567}
568EOF
569
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400570 GENERATE_BAZEL_FILES=1 run_soong
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400571 grep -q a1.txt "out/soong/bp2build/a/${GENERATED_BUILD_FILE_NAME}" || fail "a1.txt not in ${GENERATED_BUILD_FILE_NAME} file"
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200572
573 touch a/a2.txt
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400574 GENERATE_BAZEL_FILES=1 run_soong
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400575 grep -q a2.txt "out/soong/bp2build/a/${GENERATED_BUILD_FILE_NAME}" || fail "a2.txt not in ${GENERATED_BUILD_FILE_NAME} file"
Lukacs T. Berkid518e1a2021-04-14 13:49:50 +0200576}
577
Lukacs T. Berki97bb9f12021-04-01 18:28:45 +0200578function test_dump_json_module_graph() {
579 setup
580 SOONG_DUMP_JSON_MODULE_GRAPH="$MOCK_TOP/modules.json" run_soong
581 if [[ ! -r "$MOCK_TOP/modules.json" ]]; then
582 fail "JSON file was not created"
583 fi
584}
585
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400586function test_bp2build_bazel_workspace_structure {
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200587 setup
588
589 mkdir -p a/b
590 touch a/a.txt
591 touch a/b/b.txt
592 cat > a/b/Android.bp <<'EOF'
593filegroup {
594 name: "b",
595 srcs: ["b.txt"],
596 bazel_module: { bp2build_available: true },
597}
598EOF
599
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400600 GENERATE_BAZEL_FILES=1 run_soong
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200601 [[ -e out/soong/workspace ]] || fail "Bazel workspace not created"
602 [[ -d out/soong/workspace/a/b ]] || fail "module directory not a directory"
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400603 [[ -L "out/soong/workspace/a/b/${GENERATED_BUILD_FILE_NAME}" ]] || fail "${GENERATED_BUILD_FILE_NAME} file not symlinked"
604 [[ "$(readlink -f out/soong/workspace/a/b/${GENERATED_BUILD_FILE_NAME})" =~ "bp2build/a/b/${GENERATED_BUILD_FILE_NAME}"$ ]] \
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200605 || fail "BUILD files symlinked at the wrong place"
606 [[ -L out/soong/workspace/a/b/b.txt ]] || fail "a/b/b.txt not symlinked"
607 [[ -L out/soong/workspace/a/a.txt ]] || fail "a/b/a.txt not symlinked"
608 [[ ! -e out/soong/workspace/out ]] || fail "out directory symlinked"
609}
610
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400611function test_bp2build_bazel_workspace_add_file {
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200612 setup
613
614 mkdir -p a
615 touch a/a.txt
616 cat > a/Android.bp <<EOF
617filegroup {
618 name: "a",
619 srcs: ["a.txt"],
620 bazel_module: { bp2build_available: true },
621}
622EOF
623
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400624 GENERATE_BAZEL_FILES=1 run_soong
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200625
626 touch a/a2.txt # No reference in the .bp file needed
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400627 GENERATE_BAZEL_FILES=1 run_soong
Lukacs T. Berkib353cca2021-04-16 13:47:36 +0200628 [[ -L out/soong/workspace/a/a2.txt ]] || fail "a/a2.txt not symlinked"
629}
630
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200631function test_bp2build_build_file_precedence {
632 setup
633
634 mkdir -p a
635 touch a/a.txt
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400636 touch a/${GENERATED_BUILD_FILE_NAME}
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200637 cat > a/Android.bp <<EOF
638filegroup {
639 name: "a",
640 srcs: ["a.txt"],
641 bazel_module: { bp2build_available: true },
642}
643EOF
644
645 GENERATE_BAZEL_FILES=1 run_soong
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400646 [[ -L "out/soong/workspace/a/${GENERATED_BUILD_FILE_NAME}" ]] || fail "${GENERATED_BUILD_FILE_NAME} file not symlinked"
647 [[ "$(readlink -f out/soong/workspace/a/${GENERATED_BUILD_FILE_NAME})" =~ "bp2build/a/${GENERATED_BUILD_FILE_NAME}"$ ]] \
648 || fail "${GENERATED_BUILD_FILE_NAME} files symlinked to the wrong place"
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200649}
650
651function test_bp2build_reports_multiple_errors {
652 setup
653
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400654 mkdir -p "a/${GENERATED_BUILD_FILE_NAME}"
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200655 touch a/a.txt
656 cat > a/Android.bp <<EOF
657filegroup {
658 name: "a",
659 srcs: ["a.txt"],
660 bazel_module: { bp2build_available: true },
661}
662EOF
663
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400664 mkdir -p "b/${GENERATED_BUILD_FILE_NAME}"
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200665 touch b/b.txt
666 cat > b/Android.bp <<EOF
667filegroup {
668 name: "b",
669 srcs: ["b.txt"],
670 bazel_module: { bp2build_available: true },
671}
672EOF
673
674 if GENERATE_BAZEL_FILES=1 run_soong >& "$MOCK_TOP/errors"; then
675 fail "Build should have failed"
676 fi
677
Rupert Shuttleworth413a7a92021-05-18 07:47:15 -0400678 grep -q "a/${GENERATED_BUILD_FILE_NAME}' exist" "$MOCK_TOP/errors" || fail "Error for a/${GENERATED_BUILD_FILE_NAME} not found"
679 grep -q "b/${GENERATED_BUILD_FILE_NAME}' exist" "$MOCK_TOP/errors" || fail "Error for b/${GENERATED_BUILD_FILE_NAME} not found"
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200680}
681
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +0100682test_smoke
683test_null_build
Lukacs T. Berkif0b3b942021-03-23 11:46:47 +0100684test_null_build_after_docs
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +0100685test_soong_build_rebuilt_if_blueprint_changes
Lukacs T. Berki69ed2a22021-04-21 12:05:08 +0200686test_glob_noop_incremental
Lukacs T. Berkid1e3f1f2021-03-16 08:55:23 +0100687test_add_file_to_glob
688test_add_android_bp
689test_change_android_bp
690test_delete_android_bp
691test_add_file_to_soong_build
Colin Crossc02504e2021-04-08 10:34:16 -0700692test_glob_during_bootstrapping
Lukacs T. Berkif0b3b942021-03-23 11:46:47 +0100693test_soong_build_rerun_iff_environment_changes
Lukacs T. Berki97bb9f12021-04-01 18:28:45 +0200694test_dump_json_module_graph
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400695test_bp2build_smoke
Jingwen Chen4fabaf52021-05-25 02:40:29 +0000696test_bp2build_generates_fake_ninja_file
Chris Parsonsec1a3dc2021-04-20 15:32:07 -0400697test_bp2build_null_build
698test_bp2build_add_android_bp
699test_bp2build_add_to_glob
700test_bp2build_bazel_workspace_structure
701test_bp2build_bazel_workspace_add_file
Lukacs T. Berkib21166e2021-04-21 11:58:36 +0200702test_bp2build_build_file_precedence
703test_bp2build_reports_multiple_errors